#include <iostream>  
#include <fstream>   // tam jest fstream
#include <cmath>     // tam jest NAN

using namespace std;

class wektor {
	private:
	int n; // wymiar
	double *w; // elementy

	public:
	wektor( int size ) {
		w = new double[size];
		n = size;
	}

	~wektor() {
		delete [] w;
	}

	int dim() {
		return n;
	}

	double& operator[]( int i ) {
		return *(w+i);
	}

	double dlugosc( void  ) {
  	double d = 0.0;
  	for( int i= 0; i < n; i++ )
    	d += w[i]*w[i];
  	return sqrt(d);
	}

  void normalize( void ) {
  	double lgt = dlugosc( );
  	if( lgt != 0.0 ) {
    	for( int i= 0; i < n; i++ )
      	w[i] /= lgt;
  	}
	}

	double operator*( wektor &q ) {
		if( q.n != this->n )
			return 0.0;
		else {
	    double s = 0.0;
    	for( int i= 0; i < this->n; i++ )
      	s += this->w[i]*q.w[i];
    	return s;
		}
	}

	friend ostream& operator<<(ostream& os, const wektor& w);
	friend istream& operator>>(istream& is, const wektor& w);

};

ostream& operator<<(ostream& os, const wektor& w)
{
  os << "[";
	for( int i = 0; i < w.n; i++ )
		os << " " << w.w[i];
	os << " ]";
  return os;
}

istream& operator>>(istream& is, const wektor& w)
{
	for( int i = 0; i < w.n; i++ )
		is >> w.w[i];
  return is;
}

int main( int argc, char ** argv ) {
  fstream fin;

  if (argc > 1)
    fin.open(argv[1]);

	istream &in = fin.is_open() ? fin : cin;

	int n;
	in >> n;
	wektor w(n);
	in >> w;
	fin.close();

	double dw = w.dlugosc();

	cout << "w: " << w << endl;
	cout << "||w||=" << dw << endl;

	w.normalize();
	cout << "Po normalizacji: " << w << endl;
	cout << "||w||=" <<  w.dlugosc() << endl;

	if (argc > 2) {
		fin.open(argv[2]);	
		fin >> n;
		wektor u(n);
   	in >> u;
  	fin.close();

		cout << "u: " << u << endl;
  	cout << "||u||=" << u.dlugosc() << endl;

		if (w.dim() == u.dim()) {
			cout << "w*u=" << w*u << endl;
		}
	}

	return 0;
}
